package zerolog

import (
	"os"
	"time"

	"git.unotv.com/unotv-public/go_utv_utils/pkg/application"
	"github.com/rs/zerolog"
	"github.com/rs/zerolog/log"
	"github.com/rs/zerolog/pkgerrors"
)

func ConfZerolog(app *application.Application) {
	//Log Config
	//zerolog.TimeFieldFormat = zerolog.TimeFormatUnix
	zerolog.ErrorStackMarshaler = pkgerrors.MarshalStack
	zerolog.TimestampFunc = func() time.Time {
		return time.Now().In(time.Local)
	}

	// set default logger to print to stdout and prettify
	log.Logger = zerolog.New(os.Stdout).With().
		Timestamp().
		Caller().
		Logger().
		Output(zerolog.ConsoleWriter{Out: os.Stderr, TimeFormat: "2006-01-02T15:04:05"})

}
